const char *players[4] = {"Retailer", "Wholesaler", "Distributor", "Manufacturer"};
int players_policies[4], player_orders[4], player_inv[4] = {4,4,4,4}, player_delay1[4]={4,4,4,4}, player_delay2[4]={4,4,4,4}, player_backorder[4]={0,0,0,0}, player_cost[4]={0,0,0,0}, player_supply[4];
int  demandType = 0, currentDemand = 0;
int global_s = 4, global_S = 30, global_Q = 10, global_Mean = 6, global_Stdv = 2, demandMean = 6, demandStd = 2, I = 1;
float global_M = 1.96;

#define PI 3.14
void RandVal (int mean, int sigma)
{
   double u1, u2, v1, v2, s, z;
   int demandMean;
   
   do {
       u1 = rand()/(float)RAND_MAX;  // a uniform random number from 0 to 1
       u2 = rand()/(float)RAND_MAX;
       v1 = 2*u1 - 1;
       v2 = 2*u2 - 1;
       s = v1*v1 + v2*v2;
       printf("%f\n",s);
   } while (s > 1 || s==0); 
   
   z = sqrt (-2*log(s)/s)*v1;
   demandMean = (z*sigma + mean);
   return;
}
/* This function is used to select the player type the user wants*/
int selectPlayer() {
    char selection;
    printf("\nSelect Player:\nEnter R - for Retailer\nEnter W - for Wholesaler\nEnter D - for Distributor\nEnter M - for Manufacturer\nYour Choice : ");
    scanf("%c", &selection);
    switch(selection){
        case 'R' : case 'r' : return 0;
        case 'W' : case 'w' : return 1;
        case 'D' : case 'd' : return 2;
        case 'M' : case 'm' : return 3;
        default : printf("Option invalid... try again..!!\n");selectPlayer();
    }
}

/* Requests and Saves others players' policy types */
void selectPolicies(int player){
    int i = 0;
    for(i = 0; i < 4; i++)
    {
        if(i == player) continue;
        int policy = 0;
        printf("\nSelect Policy for %s\nEnter 1 - for s-S Policy\nEnter 2 - for s-Q Policy\nEnter 3 - for 'Order to S' Policy\nEnter 4 - for Echelon Policy\nEnter 5 - for Random Policy\nYour Choice : ", players[i]);
        scanf("%d", &policy);
        if(policy <= 0 || policy > 5){ i--; printf("Invalid option.. Try again.!!");continue; }
        players_policies[i] = policy;
    }
}

/* Select and Saves demandType and Demand of the player */
void selectDemand(){
    printf("\nSelect Demand Type:\nEnter 1 - for Deterministic Demand\nEnter 2 - for Random Normal\nYour Choice : ");
    scanf("%d", &demandType);
    if(demandType == 1)
    {
        printf("\nEnter const. customer's demand : ");
        scanf("%d", &demandMean);
    }
	 if(demandType == 2){ RandVal (6, 2); }
    if(demandType != 1 && demandType != 2){printf("\nOption invalid.. Try again..!!\n"); selectDemand(); }
}

int ssValue(int inv, int s, int S){
	//inv(inventory + supplyline + backorders owed - backorders),s,S
	if(inv > s) return 0;
	else return S-inv;
}
int sqValue(int inv, int s, int Q){
	//inv(inventory + supplyline + backorders owed - backorders),s,Q
	if(inv > s) return 0;
	else return Q;
}
/* order-to-S*/
int osValue(int inv, int S){
	//inv(inventory + supplyline + backorders owed - backorders),S
	if(inv > S) return 0;
	else return S-inv;
}
int ecValue(int inv, int S, float M, int player_type){
	double s;
	//inv(inventory + supplyline + backorders owed - backorders),S,M(service level),type
	switch(player_type){
	case 0:
		s = (3 * demandMean) + (global_M * demandStd * sqrt(3)); // 3 -- lead time
		break;
	case 1:
		s = (5 * demandMean) + (global_M * demandStd * sqrt(5)); 
		break;
	case 2:
		s = (7 * demandMean) + (global_M * demandStd * sqrt(7)); 
		break;
	case 3:
		s = (9 * demandMean) + (global_M * demandStd * sqrt(9)); 
		break;
	default:
		break;
	}
	if(inv > s) return 0;
	else if(s - inv < S) return s-inv;
	//else if(s - inv >= S) return S;
	else return S;
}
int rnValue(){
	return ((sqrt(-2 * log(rand())) * sin(2 * PI * rand()) * global_Stdv) + global_Mean);
}
void game(int player, int myDemand){
	int extDemand,earlier_player_order;
	if(demandType == 1) extDemand = demandMean;
	else if(demandType == 2){
		RandVal (6, 2);
		extDemand = demandMean;
	}
	int i;
	for(i = 0; i < 4; i++)
	{
		if(i == player) player_orders[i] = myDemand;
		else{
			switch(players_policies[i]){
			case 1:
				player_orders[i] = ssValue(player_inv[i] + player_delay1[i] + player_delay2[i] + (i-1 >= 0)?player_backorder[i-1]:0 - player_backorder[i], global_s, global_S);
				break;
			case 2:
				player_orders[i] = sqValue(player_inv[i] + player_delay1[i] + player_delay2[i] + (i-1 >= 0)?player_backorder[i-1]:0 - player_backorder[i], global_s, global_Q);
				break;
			case 3:
				player_orders[i] = osValue(player_inv[i] + player_delay1[i] + player_delay2[i] + (i-1 >= 0)?player_backorder[i-1]:0 - player_backorder[i], global_S);
				break;
			case 4:
				player_orders[i] = ecValue(player_inv[i] + player_delay1[i] + player_delay2[i] + (i-1 >= 0)?player_backorder[i-1]:0 - player_backorder[i], global_S, global_M, i);
				break;
			case 5:
				player_orders[i] = rnValue();
				break;
			default:
				break;
			}
		}
		player_cost[i] = player_inv[i] + 2 * player_backorder[i] + player_cost[i];
		player_inv[i] = player_inv[i] + player_delay1[i];
		player_delay1[i] = player_delay2[i];
		if(i == 0){earlier_player_order = extDemand;}
		else{
			earlier_player_order = player_orders[i-1];
		}
		if(player_inv[i] >= earlier_player_order + player_backorder[i]){
			player_inv[i] = player_inv[i] - earlier_player_order - player_backorder[i];
			if(i > 0) player_delay2[i-1] = earlier_player_order + player_backorder[i];
			player_backorder[i] = 0;
			player_supply[i] = player_backorder[i] + earlier_player_order;
		}else{
			player_backorder[i] = player_backorder[i] + earlier_player_order - player_inv[i];
			if(i > 0) player_delay2[i-1] = player_inv[i];
			player_supply[i] = player_inv[i];
			player_inv[i] = 0;
		}
	}
	
	// delay2 for manufacturer
	player_delay2[3] = player_orders[3];
}
void printArray(int *array, int N, char name[20]){
	int i;
	printf("%20s of the Players =",name);
	for(i = 0; i < N; i++)
	{
		printf("%d, ",array[i]);
	}
	printf("\n");
}
//Main simulation begins in this function
void playGame(int player){
	int demand;
	do{
		printArray(player_orders, 4, "Order Placed");
		printArray(player_backorder, 4, "Backorder");
		printArray(player_inv, 4, "Inventory");
		//printArray(player_delay1, 4);
		//printArray(player_delay2, 4);
		printf("\n Enter demand for next period or press -1 to terminate: ");
		scanf("%d", &demand);
		game(player, demand);

	}while(demand != -1);
}
